﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Microsoft.Kinect;

namespace HelloKinectWorldWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        KinectSensor sensor;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            sensor = KinectSensor.KinectSensors[0];
            sensor.ColorStream.Enable(ColorImageFormat.RgbResolution640x480Fps30);
            sensor.ColorFrameReady += FrameReady;
            sensor.Start();
        }

        void FrameReady(object sender, ColorImageFrameReadyEventArgs e)
        {
            ColorImageFrame imageFrame = e.OpenColorImageFrame();
            if (imageFrame != null)
            {
                BitmapSource bmap = ImageToBitmap(imageFrame);
                image1.Source = bmap;
            }
        }

        BitmapSource ImageToBitmap(ColorImageFrame Image)
        {
            byte[] pixeldata = new byte[Image.PixelDataLength];
            Image.CopyPixelDataTo(pixeldata);
            BitmapSource bmap = BitmapSource.Create(
             Image.Width,
             Image.Height,
             96, 96,
             PixelFormats.Bgr32,
             null,
             pixeldata,
             Image.Width * Image.BytesPerPixel);
            return bmap;
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            sensor.Stop();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            sensor.ElevationAngle += 4;
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            sensor.ElevationAngle -= 4;
        }
    }
}